clear all;close all;clc %#ok<CLALL>
load('AB.mat')    % All spacebar press scores (0 = miss, 1 = hit)                                    92 pp x 7 videos from low to high effort x 200 matrix   Note. 94, 76, 81, 74, 88, 115, 92 scores for videos 1-7
load('AS.mat')    % All visual sampling scores (0 = miss, 1 = hit)                                   92 pp x 7 videos from low to high effort x 200 matrix   Note. 94, 76, 81, 74, 88, 115, 92 scores for videos 1-7
load('DSP.mat')   % Visual sampling score (0 = lowest possible , 1 = highest possible)               92 pp x 7 videos from low to high effort                Note. Same as nanmean(AS,3)
load('LD.mat')    % Contains dial numbers from 1 to 6                                                92 pp x 7 videos from low to high effort x 4 matrix
                  % 1. Last dial to be responded to (1 = left top, 6 = right bottom)
                  % 2. Last dial to be responded to (1 = low bandwidth, 6 = highest bandwidth)
                  % 3. Last dial actually responded to (1 = left top, 6 = right bottom)
                  % 4. Last dial actually responded to (1 = low bandwidth, 6 = highest bandwidth)
load('NFUPD.mat') % number of fixations per dial, not counting re-fixations                          92 pp x 7 videos from low to high effort x 6 dials from left top to right bottom
load('NPTBP.mat') % number of required spacebar presses (i.e., threshold crossings)                  92 pp x 7 videos from low to high effort. Note. 94, 76, 81, 74, 88, 115, 92 scores for videos 1-7
load('Q1c.mat')   % What was the last dial you responded to? (1 = left top, 6 = right bottom)        92 x 7 videos in order of presentation
load('Q2c.mat')   % What is the next dial you will respond to? (1 = left top, 6 = right bottom)      92 x 7 videos in order of presentation
load('Q3c.mat')   % How confident are you about your answers? (1 = very unsure, 10 = very sure)      92 x 7 videos in order of presentation
load('Q4c.mat')   % How much eye-movement effort did you experience? (1 = very low, 10 = very high)  92 x 7 videos in order of presentation
load('InvalidPP.mat') % Vector with participant numbers of participants who were excluded (N = 6)
load('NFP.mat')   % Number of false positives (space presses not associated with treshold crossings) 92 pp x 7 videos from low to high effort
load('NH.mat')    % Number of hits (space presses associated with threshold crossings)               92 pp x 7 videos from low to high effort. Note. nansum(AB,3)
load('Dial_config') % The bandwidth of each dial (1 = 0.03 Hz, 6 = 0.48 Hz)                          7 videos from low to high effort x 6 dials from left top to right bottom
load('o')         % Order of video presentation. For example,  6 1 5 7 3 4 2 means that the first presentated video is Video 6 (effort level 6)    92 x 7 videos in order of presentation                                                                             92 pp x 7 matrix
load('X')         % 1. Participant age
                  % 2. Gender (1 = male, 2 = female)
                  % 3. proportion correct out of total number of dials (typically 42) ,PC =100*(MM(:,1)+MM(:,4))./sum(MM,2)
                  % 4. mean confidence (mean(Q3c,2)
                  % 5. mean effort (mean(Q4c,2)   92 pp x 5 matrix
load('PA')        % participant's angle (blue pen) with respect to threshold (dashed line), negative = CCW wrt dashed line, positive = CW wrt dashed line  92 pp x 7 videos in order of presentation * 6 dials matrix from left top to right bottom. Note PA = -(rad2deg(angdiff(deg2rad((DK(:,:,:))),deg2rad((DBi(:,:,:))))));
load('DBi')       % participant's angle (blue pen), 0 deg = pointing toward the right                92 pp x 7 videos in order of presentation * 6 dials matrix from left top to right bottom
load('DK')        % threshold (dashed line), 0 deg = pointing toward the right                       92 pp x 7 videos in order of presentation * 6 dials matrix from left top to right bottom 
load('DZ')        % true threshold angle, 0 deg = pointing toward the right                          92 pp x 7 videos in order of presentation * 6 dials matrix from left top to right bottom. Note % Note. 2 incorrect SAGAT sheets for PP7, incorrect SAGAT sheet for PP68, SAGAT sheet missing for PP70
load('MM')        % Matrix with participant scores                                                   92 pp x 5 scores
                  % 1 = Ground truth CW w.r.t. dashed line & Participant CW w.r.t. dashed line   (0 = no, 1 = yes)
                  % 2 = Ground truth CW w.r.t. dashed line & Participant CCW w.r.t. dashed line  (0 = no, 1 = yes)
                  % 3 = Ground truth CCW w.r.t. dashed line & Participant CW w.r.t. dashed line  (0 = no, 1 = yes)
                  % 4 = Ground truth CCW w.r.t. dashed line & Participant CCW w.r.t. dashed line (0 = no, 1 = yes)
                  % 5 = No line drawn (0 = no, 1 = yes)
gtwtz=[   -1.47413596599752          26.2469668147386          73.5185581220948          10.2092759945081         -65.8567616535858          -41.219116096016
          54.2743217901859         -47.0814054759156          11.8890640657687         -56.2988228139689         -17.6414794915177          5.67223219272009
         -117.077035069735          60.8744645323294          61.9637629837752         -93.3876527164907         -30.2811171272576         -4.57510526433896
         -14.3104631146642          66.6730558437705         -31.8660245157572         -62.9747061377757         -20.3619951292312           5.3663149622378
          57.3052123392126          15.1004649752095         -65.9983734951903          167.839113178686          4.93921103843341       -0.0629058573792266
         -57.4077953784567          67.5602199938922          -31.572036490994          141.231942878135          70.1878244252645         -24.3716827768008
          44.753258149549         -95.3156516678279          126.938372472444         -109.472697725128         -26.2050420618751         -70.3146979683314]; 
       % ground truth angles for the 7 videos and the six dials.
       % (i.e., pointer position at the end of video relative to dashed line)
       % 7 videos from low to high effort x 6 dials from left top to right bottom
       % negative = CCW wrt dashed line, positive = CW wrt dashed line
load('GTWTZ','GTWTZ') % same but now 92 pp x 7 videos from low to high effort x 6 dials from left top to right bottom

% for i=1:92 % loop over number of participants
%     temp=squeeze(GTWTZ(i,:,:)); % ground truth with respect to zero, for participant i
%     temp2=squeeze(PA(i,:,:));   % participant angle (blue line) with respect to zero angle (dashed line), for participant i (positive = CW, negative = CCW)
%     temp3=squeeze(DBi(i,:,:));  % participant's angle (bline line)
%     temp(isnan(temp3) | temp3<-1000)=NaN;  % if there is no blue pointer drawn, then also do not calculate GTWTZ
%     temp2(isnan(temp3) | temp3<-1000)=NaN; % if there is no blue pointer drawn, then also do not calculate PA
%     MM(i,1)=sum(sum(temp>0 & temp2 >0)); % Ground truth CW w.r.t. dashed line & Participant CW w.r.t. dashed line (0 = incorrect, 1 = correct)
%     MM(i,2)=sum(sum(temp>0 & temp2 <0)); % Ground truth CW w.r.t. dashed line & Participant CCW w.r.t. dashed line (0 = incorrect, 1 = correct)
%     MM(i,3)=sum(sum(temp<0 & temp2 >0)); % Ground truth CCW w.r.t. dashed line & Participant CW w.r.t. dashed line (0 = incorrect, 1 = correct)
%     MM(i,4)=sum(sum(temp<0 & temp2 <0)); % Ground truth CCW w.r.t. dashed line & Participant CCW w.r.t. dashed line	(0 = incorrect, 1 = correct)
%     MM(i,5)=sum(sum(temp3<-1000));       % No line drawn
% end

% Last dial, correct answers
a=NaN(7,1);b=NaN(7,1);clast=NaN(7,1);for i=1:7;[~,t,BP,AM,BPt]=signal_for_dial(90,i);[a(i),b(i)]=max(nanmax(BPt,[],2));[~,clast(i)]=find(Dial_config(i,:)==b(i));end

% Next dial, correct answers
a=NaN(7,1);b=NaN(7,1);cnext=NaN(7,1);for i=1:7;[~,t,BP,AM,~,temp2next,BPtnext]=signal_for_dialn(90,i);BPtnext(BPtnext<=4500)=NaN;[a(i),b(i)]=min(nanmin(BPtnext,[],2));[~,cnext(i)]=find(Dial_config(i,:)==b(i));end
%%
disp('Cross-tabulation of individual samplings and spacebar presses, per threshold crossing')
temp1=reshape(AB,92*7*200,1); % All spacebar press scores (0 = miss, 1 = hit)
temp2=reshape(AS,92*7*200,1); % All visual sampling scores (0 = miss, 1 = hit)
disp(      'Sampling = 0, Sampling = 1')
disp('Spacebar pressed = 0')
disp('Spacebar pressed = 1')
temp=crosstab(temp1,temp2);
disp(temp)
disp('Percentages')
disp(100*temp./repmat(sum(temp),2,1))
disp('Phi coefficient')
disp(corr(temp1,temp2,'rows','pairwise'))
%%
close all
%temp=nansum(NFUPD,3)/90;temp(temp==0)=NaN;temp=nanmean(temp,2);
%X(:,6)=temp;
X(:,7:9)=[100*nanmean(DSP,2) 100*nanmean(NH./NPTBP,2) 100*nanmean(NFP./NPTBP,2)];  
% 7 = proportion of dials fixated (visual sampling score)
% 8 = hit rate (performance score)
% 9 = false positive rate

X(InvalidPP,:)=NaN; %  24, 25 = crash, 33 = no show, 42, 50 = participants with glasses who watched a different video
% In addition, PP 18 and PP 22 have no SAGAT sheets
figure;hold on
subplot(1,2,1);hold on
PP=find(~isnan(X(:,3)+X(:,8)));
plot(X(PP,3),X(PP,8),'ko','Markerfacecolor','k','Markersize',10)
P=polyval(polyfit(X(PP,3), X(PP,8),1),[0 100]);
plot([0 100],P,'b--','linewidth',3)
axis equal;box on
set(gca,'xlim',[35 80])
set(gca,'ylim',[25 70])
xlabel('Freeze-probe score (%)')
ylabel('Performance score (%)')
grid on
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',18)
set(gca, 'LooseInset', [0.02 0.02 0.02 0.02]);
disp('Correlation between freeze-probe score and performance score')
disp([length(PP) corr(X(PP,3), X(PP,8))])

subplot(1,2,2);hold on
plot(X(PP,7),X(PP,8),'ko','Markerfacecolor','k','Markersize',10)
P=polyval(polyfit(X(PP,7), X(PP,8),1),[0 100]);
plot([0 100],P,'b--','linewidth',3)
axis equal;box on
set(gca,'xlim',[40 85])
set(gca,'ylim',[25 70])
xlabel('Sampling score (%)')
ylabel('Performance score (%)')
grid on
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',18)
set(gca, 'LooseInset', [0.02 0.02 0.02 0.02]);
disp('Correlation between sampling score and performance score')
disp([length(PP) corr(X(PP,7), X(PP,8))])
disp('Mean and SD freeze-probe score')
disp([mean(X(PP,3)) std(X(PP,3))])
%%
Q1cEE=NaN(92,7);
Q2cEE=NaN(92,7);
Q3cEE=NaN(92,7);
Q4cEE=NaN(92,7);
for pp=1:92
    temp=o(pp,:);temp(isnan(temp))=[];
    if pp==41
        temp(7)=6;
    end
    % sort answers to questions on effort level
    Q1cEE(pp,temp)=Q1c(pp,1:length(temp)); % what is the last dial you responded to? (A to F)
    Q2cEE(pp,temp)=Q2c(pp,1:length(temp)); % what is the next dial you will respond to? (A to F)
    Q3cEE(pp,temp)=Q3c(pp,1:length(temp)); % how confident are you about your answers? (1 = very unsure, 10 = very sure)
    Q4cEE(pp,temp)=Q4c(pp,1:length(temp)); % how much eye-movement effort did you experience? (1 = very low, 10 = very high) 
end
disp('Mean and SD confidence')
disp([nanmean(nanmean(Q3cEE(:,:),2)) nanstd(nanmean(Q3cEE(:,:),2))])
LD(41,6,1)=6;

Last_Correct2=100*double(Q1cEE==LD(:,:,3)); % 100 if answer to question corresponds to the last dial the participant actually responded to
Last_Correct2(isnan(LD(:,:,3)))=NaN;
Last_Correct2=nanmean(Last_Correct2,2); 
Last_Correct=100*sum(Q1cEE==repmat(clast',92,1),2)./sum(~isnan(Q1cEE),2); % 100 if the answer corresponds to the last dial the participant shoudl have responded to
% 92 x 1 matrix % 2 5 3 1 6 6 3 = correct dial number (corresponding to 6 2 4 5 5 6 4 when sorted on bandwidth)
Next_Correct=100*sum(Q2cEE==repmat(cnext',92,1),2)./sum(~isnan(Q2cEE),2);
%%
disp('Mean and SD last dial, actual hit where participant pressed spacebar for a threshold crossing')
disp([mean(Last_Correct2(PP)) std(Last_Correct2(PP))])
disp('Mean and SD hit rate for the last dial which the participant had to respond to (last threshold crossing)')
disp([mean(Last_Correct(PP)) std(Last_Correct(PP))])
disp('Mean and SD hit rate for the next dial which the participant should respond to (next threshold crossing)')
disp([mean(Next_Correct(PP)) std(Next_Correct(PP))])
disp('Correlations between last dial and 1. freeze-probe score, 2. sampling score, 3. performance score')
disp(corr(Last_Correct(PP),X(PP,[3 7 8])))
disp('Correlations between last dial _ actual and 1. freeze-probe score, 2. sampling score, 3. performance score')
disp(corr(Last_Correct2(PP),X(PP,[3 7 8])))
disp('Correlations between next dial and 1. freeze-probe score, 2. sampling score, 3. performance score')
disp(corr(Next_Correct(PP),X(PP,[3 7 8])))