function [alldata,t,BP,AM,BPt] = signal_for_dial(t_end,rg)
rng(rg); % rg should be 1, 2, 3, ... (this makes the numbers repeatable)
Fs=50; % sampling frequency
L=t_end*Fs; % number of sample points
T=1/Fs; % sampling period
t=(0:L-1)*T; % time vector
cutoff=[.03 .05 .12 .20 .32 .48]; % Senders 1983
c=logspace(log10(0.001),log10(1),40);
c=unique([c cutoff]);
BPt=NaN(length(cutoff),round(t_end));
alldata=NaN(length(t),length(cutoff));
AM=NaN(length(cutoff),1);
BP=AM;
for j = 1:length(cutoff)
    cc=c;
    cc(cc>cutoff(j))=[];
    am=length(cc);
    d = 9999*rand(am,1); % random phase shifts
    y = NaN(am,length(t));
    for i = 1:am % loop for making the signal
        y(i,:) = sin(2*pi*cc(i)*(t+d(i))); % define each of the 6 signals
    end
    yn=sum(y)';
    yn = yn - mean(yn); % make sure that the total signal has a mean of zero
    yn = (yn./std(yn)); % make sure that the total signal has a SD of 1
    alldata(:,j) = yn;  % store the signal for this cut-off frequency
    AM(j)=am;           % number of sinusoids
end
alldata=pi*alldata/3.59247397659283;
close all

for j=1:length(cutoff) % loop over the 6 bandwidhts
    temp=find(abs(diff(alldata(:,j)>0))==1);
    BP(j)=length(temp); % number of threshold crossings
    BPt(j,1:length(temp))=temp; % threshold crossing times
end