function [alldata,t,BP,AM,BPt,alldatanext,BPtnext] = signal_for_dial_j5n(t_end,rg)
rng(rg); % rg should be 1, 2, 3, ... (this makes the numbers repeatable)
Fs=50; % sampling frequency
L=t_end*Fs; % length of signal
T=1/Fs; % sampling period
t=(0:L-1)*T; % time vector
tnext=(0:L*2-1)*T; % time vector
V=[-pi:0.01:pi pi]; % vector for density from
f = Fs*(0:L/2)/L;
cutoff=[.03 .05 .12 .20 .32 .48]; % Senders 1983
c = logspace(log10(0.001),log10(1),40);
c=unique([c cutoff]);
BPt=NaN(length(cutoff),round(t_end));
BPtnext=NaN(length(cutoff),round(t_end*2));
% am uniformly random numbers between 0 and cutoff frequency in rad/s (Elkind & Forgie, 1959)
alldata=NaN(length(t),length(cutoff));
alldatanext=NaN(length(tnext),length(cutoff));
AM=NaN(length(cutoff),1);
BP=AM;

for j = 1:length(cutoff)
    cc=c;
    cc(cc>cutoff(j))=[];
    am=length(cc);
    
    d = 9999*rand(am,1);                % random phase shifts
    y = NaN(am,length(t));
    ynext = NaN(am,length(tnext));
    
    for i = 1:am    % run loop with making of the signal
        y(i,:) =     sin(2*pi*cc(i)*(t+d(i))); % define each of the am signals
        ynext(i,:) = sin(2*pi*cc(i)*(tnext+d(i))); % define each of the am signals
    end
    yn=sum(y)';
    MYN = mean(yn);
    yn = yn - mean(yn);  % make sure that the total signal has a mean of zero
    SDN=std(yn);
    yn = yn./SDN;        % make sure that the total signal has a SD of 1
    alldata(:,j) = yn;   % store the signal for this cut-off frequency

    ynext=sum(ynext)';
    ynext = ynext - MYN;       % make sure that the total signal has a mean of zero
    ynext = ynext./SDN;        % make sure that the total signal has a SD of 1
    alldatanext(:,j) = ynext;  % store the signal for this cut-off frequency

    AM(j)=am;  % number of sinusoids
end


alldata=pi*alldata/3.59247397659283;
alldatanext=pi*alldatanext/3.59247397659283;
for j=1:length(cutoff) % loop to make some figures
    yn=alldata(:,j);
    ynnext=alldatanext(:,j);

    temp=find(abs(diff(yn>0))==1);
    tempnext=find(abs(diff(ynnext>0))==1);
    
    BP(j)=length(temp);
    BPt(j,1:length(temp))=temp; % button press times
    BPtnext(j,1:length(tempnext))=tempnext; % button press times
    
end